/*
 * ClientDisplay.java
 *
 * Created on December 9, 2002, 4:04 PM
 */

package demo;

import javax.swing.*;

/** <P>The JPanel used by the client.</P>
 * @author Brice Daniels
 * @version .4
 */
public class ClientDisplay extends javax.swing.JPanel {
    private Client client;
    
    /** <P>Creates new ClientDisplay.</P>
     * @param client The parent client for this panel.
     */
    public ClientDisplay(Client client) {
        this.client = client;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jSeparator2 = new javax.swing.JSeparator();
        jButton1 = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        setName("Client Share");
        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setText("Client Share " + client.getShareNumber());
        jLabel1.setToolTipText("Client Share");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(jLabel1, gridBagConstraints);

        jLabel2.setText("Secret");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        add(jLabel2, gridBagConstraints);

        jTextField1.setEditable(false);
        jTextField1.setText(client.getSecret());
        jTextField1.setToolTipText("Secret Share");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 100;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        add(jTextField1, gridBagConstraints);

        jLabel4.setText("Original Secret");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        add(jLabel4, gridBagConstraints);

        jTextField3.setEditable(false);
        jTextField3.setText(client.getOriginalSecret());
        jTextField3.setToolTipText("The original secret");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        add(jTextField3, gridBagConstraints);

        jLabel3.setText("Commitment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        add(jLabel3, gridBagConstraints);

        jTextField2.setEditable(false);
        jTextField2.setText(client.getCommitment());
        jTextField2.setToolTipText("Commitment Value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        add(jTextField2, gridBagConstraints);

        jLabel5.setText("Original Commitment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        add(jLabel5, gridBagConstraints);

        jTextField4.setEditable(false);
        jTextField4.setText(client.getOriginalCommitment());
        jTextField4.setToolTipText("The original commitment value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        add(jTextField4, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridLayout(1, 0));

        jSeparator2.setPreferredSize(new java.awt.Dimension(160, 2));
        jPanel3.add(jSeparator2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(jPanel3, gridBagConstraints);

        jButton1.setMnemonic('c');
        jButton1.setText("Corrupt");
        jButton1.setToolTipText("Corrupt this Share");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                corruptHandler(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 0);
        add(jButton1, gridBagConstraints);

    }//GEN-END:initComponents

    private void corruptHandler(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_corruptHandler
        // Add your handling code here:
        try {
            this.client.corruptShare();
        } catch (Exception e) {
            displayError("Corrupt Share Operation Error",e.toString());
        }
    }//GEN-LAST:event_corruptHandler
    
    /** <P>Displays an error dialog box.</P>
     * @param title The title for the error box.
     * @param error A string with the error message.
     */    
    protected void displayError(String title, String error) {
        JOptionPane.showMessageDialog(this, error, title, JOptionPane.ERROR_MESSAGE);
    }
    
    /** <P>Updates the values displayed on the panel.</P>
     */    
    protected void updateDisplay() {
        this.jTextField1.setText(client.getSecret());
        this.jTextField2.setText(client.getCommitment());
        this.jTextField3.setText(client.getOriginalSecret());
        this.jTextField4.setText(client.getOriginalCommitment());
    }
    
    /** <P>Locks the state of the client. AKA, disables the "Corrupt" button</P>
     */    
    protected void lockState() {
        this.jButton1.setEnabled(false);
    }
    
    /** <P>Unlocks the state of the client. AKA, re-enables the "Corrupt" button.</P>
     */    
    protected void unlockState() {
        this.jButton1.setEnabled(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel4;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton jButton1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JLabel jLabel5;
    // End of variables declaration//GEN-END:variables
    
}
